<?php
if( !class_exists(EeweeCustomAdmin)){
	
	class EeweeCustomAdmin extends WP_Query{
		
		function __construct(){
			add_action('init', array( 'EeweeCustomAdmin', 'init'));
		}//fin constructeur

		function eewee_activate(){ /*echo "execute lors de l'activation du plugin";*/ }
		function eewee_deactivate(){ /*echo "execute lors de la désactivation du plugin";*/ }
		
		/**
		 * 
		 * Gestion des menus du plugin
		 */
		function eewee_adminMenu(){
			/*
			// menu A
			add_menu_page( "Matos", "Matos", "manage_options", "idGestionMatos", array($this, menu) );
			// sous menu dans B
			add_submenu_page( "idGestionMatos", "Liste", "Liste", "manage_options", "idSousGestionMatosCA2", array($this, 'sousMenuGestionMatos2') );
			*/		
			// appel init
			//add_action('admin_init', array($this, 'init'));
		}
		
		/**
		 * 
		 * Page : menu principale
		 * Contenu de la page docs
		 */
		//function menu(){ include( EEWEE_CUSTOM_ADMIN_PLUGIN_DIR . '/front-end/docs.php' ); }

		/**
		 * 
		 * Page : sousMenuGestionMatos2
		 * Contenu de la page liste
		 */
		//function sousMenuGestionMatos2(){ include( EEWEE_CUSTOM_ADMIN_PLUGIN_DIR . '/front-end/liste.php' ); }

		/**
		 * 
		 * menu
		 */
		function init(){
			// favicon
                        if( EEWEE_CUSTOM_ADMIN_URL_FAVICON_ENABLED ){
                            add_action('admin_head', array( 'EeweeCustomAdmin', 'eewee_favicon'));
                        }
			
                        // admin logo
                        if( EEWEE_CUSTOM_ADMIN_URL_ADMIN_LOGO_ENABLED ){
                            add_action('admin_head', array( 'EeweeCustomAdmin', 'eewee_admin_logo'));
                        }
			
			// footer de l'admin
			add_filter('admin_footer_text', array( 'EeweeCustomAdmin', 'eewee_admin_footer'));			
			
			// tableau de bord : ajouter zone
			add_action('wp_dashboard_setup', array( 'EeweeCustomAdmin', 'eewee_dashboard_widgets'));
			
			// tableau de bord : desactiver zone
			//add_action('admin_menu', array( 'EeweeCustomAdmin', 'disable_default_dashboard_widgets'));
			
			// tableau de bord : custom zone "aujourd'hui", ajouter infos
			//add_action('right_now_content_table_end', array( 'EeweeCustomAdmin', 'portfolio_in_today'));
			
			// tableau de bord : custom zone "aujourd'hui", supprimer infos
			//add_action('admin_head', array( 'EeweeCustomAdmin', 'eewee_admin_head'));
			
			// supprimer le message de maj de wordpress pour les non admin
			if( EEWEE_CUSTOM_ADMIN_MESSAGE_UPDATE_FOR_NO_ADMIN ){
                            self::eewee_admin_no_message_update();
                        }

			// supprime les infos des colonnes dans x (page, article, media, ...)
			if( EEWEE_CUSTOM_ADMIN_DELETE_INFORMATION_COLUMN_PAGE == true ){
                            add_filter('manage_pages_columns', array( 'EeweeCustomAdmin', 'custom_post_page_columns'));
                        }
                        if( EEWEE_CUSTOM_ADMIN_DELETE_INFORMATION_COLUMN_POST == true ){
                            add_filter('manage_posts_columns', array( 'EeweeCustomAdmin', 'custom_post_page_columns'));
                        }
                        if( EEWEE_CUSTOM_ADMIN_DELETE_INFORMATION_COLUMN_MEDIA == true ){
                            add_filter('manage_media_columns', array( 'EeweeCustomAdmin', 'custom_post_page_columns'));
                        }

			//----------------------------------			
			// WYSIWYG
			//----------------------------------
			
			// mettre editeur HTML par defaut
			//add_filter( 'wp_default_editor', create_function('', 'return "html";') );
			
			// mettre editeur VISUEL par defaut
			//add_filter( 'wp_default_editor', create_function('', 'return "tinymce";') );
			
			// supprimer editeur VISUEL
			//add_filter ( 'user_can_richedit' , create_function ( '$a' , 'return false;' ) , 50 );
			
			// Empecher l'éditeur visuel de faire sa sauce avec les balises
			// Attention : si vous avez installé le plugin Tiny MCE advanced, il faut aussi aller dans le fichier wp-content/plugins/tinymce-advanced/tinymce-advanced.php. Actuellement à la ligne 215, commenter $c = wpautop($c);
			//remove_filter('the_content', 'wpautop');
			//remove_filter('the_excerpt', 'wpautop');

			//----------------------------------
			// ADMIN 
			//----------------------------------
			
			// supprime les zones sous le WYSIWYG post/page (ex: champs personnalises, discussion, commentaire, ...) 
			//add_action( 'admin_menu' , array('EeweeCustomAdmin', 'remove_extra_meta_boxes'));
			
			//----------------------------------
			// MENU, SOUS MENU
			//----------------------------------
			
			// supprime menu colonne de gauche
			//add_action('admin_menu', array('EeweeCustomAdmin', 'remove_admin_menus'));
			
			// supprime menu et/ou sous menu colonne de gauche
//			add_action('admin_menu', array('EeweeCustomAdmin', 'custom_admin_menu'), 11);
			
			// voir la structure php de $menu et $submenu
			//add_filter('admin_footer_text', array('EeweeCustomAdmin', 'custom_footer_admin'));

			//----------------------------------
			// AIDE (fonctionne pas)
			//----------------------------------

			//add_action('load-page-new.php', array('EeweeCustomAdmin', 'custom_help_page'));
			//add_action('load-page.php', array('EeweeCustomAdmin', 'custom_help_page'));
			
			//----------------------------------
			// USER 
			//----------------------------------
			
			// user : ajouter champ
			if( EEWEE_CUSTOM_ADMIN_ADD_INFORMATION_USER_PROFIL ){
                            add_filter('user_contactmethods', array('EeweeCustomAdmin', 'eewee_new_contactmethods'),10,1);
                        }
                        
			//----------------------------------
			// INFO
			//----------------------------------
					
			// Info : ajouter avertissement haut de page
			add_action( 'admin_notices', array('EeweeCustomAdmin', 'eewee_admin_notice') );
		}
		
                
                
                
                
                
                
                
		/**
		 * Favicon custom
		 */
		function eewee_favicon() {
			echo '<link rel="shortcut icon" href="'.EEWEE_CUSTOM_ADMIN_URL_FAVICON_ICO.'" />';
			echo '<link rel="apple-touch-icon" href="'.EEWEE_CUSTOM_ADMIN_URL_FAVICON_PNG.'"/>';
		}
		
                /**
		 * Admin logo
		 */
		function eewee_admin_logo() {
			//$templ_url = get_bloginfo('template_url');
			echo '<style type="text/css">#header-logo{background-image:url('.EEWEE_CUSTOM_ADMIN_URL_ADMIN_LOGO.')!important;width:62px!important;height:36px!important;margin:7px 0 0 185px!important;}'
				.'#adminmenu{margin:15px 5px 15px -170px;width:155px;}</style>';
		}
		
		/**
		 * Footer admin
		 */
		function eewee_admin_footer(){
			echo "
                        Realisation <a href='".EEWEE_CUSTOM_ADMIN_URL_SITE."'>".EEWEE_CUSTOM_ADMIN_NAME_SITE."</a> / 
		   	Nous contacter : <a href='mailto:".EEWEE_CUSTOM_ADMIN_EMAIL."'>email</a>
                        ";
		}
		
		/**
		 * tableau de bord : infos concernant la maj des plugins
		 */
		function no_update_widget() {
			echo EEWEE_CUSTOM_ADMIN_FIXE_MESSAGE_DASHBOARD;
		}
		function images_widget() {
			echo '<p><b>Xxx :</b> xxx xxx xxx.</p>';
		}
		function eewee_dashboard_widgets() {
			if ( current_user_can('update_core') ){
				wp_add_dashboard_widget(
					'eewee_custom_help_widget1', 
					EEWEE_CUSTOM_ADMIN_FIXE_TITLE_DASHBOARD, 
					array('EeweeCustomAdmin', 'no_update_widget')
				);
			}
			/*
			wp_add_dashboard_widget(
				'eewee_custom_help_widget2', 
				'Images', array('EeweeCustomAdmin', 
				'images_widget')
			);
                        */
		}
		
		/**
		 * tableau de bord : desactiver zone
		 */
		function disable_default_dashboard_widgets() {
			remove_meta_box('dashboard_right_now', 'dashboard', 'core');
			remove_meta_box('dashboard_recent_comments', 'dashboard', 'core');
			remove_meta_box('dashboard_incoming_links', 'dashboard', 'core');
			remove_meta_box('dashboard_plugins', 'dashboard', 'core');
			remove_meta_box('dashboard_quick_press', 'dashboard', 'core');
			remove_meta_box('dashboard_recent_drafts', 'dashboard', 'core');
			remove_meta_box('dashboard_primary', 'dashboard', 'core');	// Autres news WordPress
			remove_meta_box('dashboard_secondary', 'dashboard', 'core');	// News WordPress
		}

		/**
		 * tableau de bord : custom zone "aujourd'hui", ajouter infos
		 * 
		 * attention : ajoute l'info sur un post type "portfolio", que vous avez cree
		 */
		function portfolio_in_today() {
			$types = 'portfolio';
		        if (!post_type_exists(''.$types.'')) { return; }
		        $num_posts = wp_count_posts( ''.$types.'' );
		        $nbr_ = 'Projet';
			$nbr_s = 'Projets';
		        $num = number_format_i18n( $num_posts->publish );
		        $text = _n('' . $nbr_ . '', '' . $nbr_s . '', intval($num_posts->publish) );
		        if ( current_user_can( 'edit_posts' ) ) {
		            $num = "<a href='edit.php?post_type=$types'>$num</a>";
		            $text = "<a href='edit.php?post_type=$types'>$text</a>";
		        }
		        echo '<tr><td class="first b">' . $num . '</td><td class="t">' . $text . '</td></tr>';
		        if ($num_posts->pending > 0) {
		            $num = number_format_i18n( $num_posts->pending );
		            $text = _n( 'En attente', 'En attentes', intval($num_posts->pending) );
		            if ( current_user_can( 'edit_posts' ) ) {
		                $num = "<a href='edit.php?post_status=pending&post_type=$types'>$num</a>";
		                $text = "<a class='waiting' href='edit.php?post_status=pending&post_type=$types'>$text</a>";
		            }
		            echo '<tr><td class="first b">' . $num . '</td><td class="t">' . $text . '</td></tr>';
		        }
		}

		/**
		 * tableau de bord : custom zone "aujourd'hui", supprimer infos
		 * 
		 * .table_discussion : commentaires,
		 * .b.b-posts,.t.posts : posts,
		 * .b.b-pages,.t.pages : pages,
		 * .b.b-cats,.t.cats : catégories,
		 * .b.b-tags,.t.tags : mots clés.
		 */
		function eewee_admin_head() {
			$blog_url = get_bloginfo('url');
			$templ_url = get_bloginfo('template_url');
			echo '<link rel="shortcut icon" href="'.$blog_url.'/favicon.ico" />';
			echo '<link rel="apple-touch-icon" href="'.$blog_url.'/apple-touch-icon.png"/>';
			echo '<style type="text/css">#header-logo{background-image:url('.$templ_url.'/images/logo-admin.png)!important;width:62px!important;height:36px!important;margin:7px 0 0 185px!important;}'
				.'#adminmenu{margin:15px 5px 15px -170px;width:155px;}'
				.'.table_discussion,.b.b-posts,.t.posts,.b.b-cats,.t.cats,.b.b-tags,.t.tags{display:none;}</style>';
		}

		/**
		 * supprimer le message de maj de wordpress pour les non admin
		 */
		function eewee_admin_no_message_update(){
			if (!current_user_can('update_plugins')) {
				add_action('admin_init', create_function(false,"remove_action('admin_notices', 'update_nag', 3);"));
			}
		}
		
		/**
		 * supprime les infos des colonnes dans x (page, article, media, ...)
		 * @param array $defaults
		 */
		function custom_post_page_columns($defaults) {
			unset($defaults['author']);	// Auteur
			unset($defaults['comments']);	// Commentaires
			unset($defaults['date']);	// Date
			return $defaults;
		}

		/**
		 * supprime les zones sous le WYSIWYG post/page (ex: champs personnalises, discussion, commentaire, ...) 
		 */
		function remove_extra_meta_boxes() {
			remove_meta_box( 'postcustom' , 'page' , 'normal' );
			remove_meta_box( 'commentsdiv' , 'page' , 'normal' );
			// <div id="commentstatusdiv" class="postbox">
			remove_meta_box( 'commentstatusdiv' , 'page' , 'normal' );
		}
		
		/**
		 * supprime menu colonne de gauche
		 */
		function remove_admin_menus() {
			global $menu;
			if ( current_user_can('update_core') ){
				$restricted = array( 
					//__('Dashboard'), 
					//__('Posts'), 
					__('Media'), 
					__('Links'), 
					//__('Pages'), 
					//__('Appearance'), 
					__('Tools'), 
					//__('Users'), 
					//__('Settings'), 
					__('Comments'), 
					//__('Plugins')
				);
			}else{
				$restricted = array( 
					__('Dashboard'), 
					//__('Posts'), 
					__('Media'), 
					__('Links'), 
					//__('Pages'), 
					__('Appearance'), 
					__('Tools'), 
					__('Users'), 
					__('Settings'), 
					__('Comments'), 
					__('Plugins')
				);
			}
			end ($menu);
		 
			while (prev($menu)) {
				$value = explode(' ',$menu[key($menu)][0]);
				if(in_array($value[0] != NULL?$value[0]:"" , $restricted)) {
					unset($menu[key($menu)]);
				}
			}
		}
		
		/**
		 * 
		 * 
		 * 	MENU
		 *  $menu[2] : Tableau de bord,
		 *	$menu[4] : Séparateur,
		 *	$menu[5] : Articles,
		 *	$menu[10] : Médias,
		 *	$menu[15] : Liens,
		 *	$menu[20] : Pages,
		 *	$menu[21] : Votre custom post type (en fait ça dépend de la façon dont votre post type est déclaré),
		 *	$menu[25] : Commentaires,
		 *	$menu[59] : Séparateur,
		 *	$menu[60] : Apparence,
		 *	$menu[65] : Extensions,
		 *	$menu[70] : Utilisateurs,
		 *	$menu[75] : Outils,
		 *	$menu[80] : Réglages,
		 *	$menu[99] : Séparateur "vide",
		 *	$menu[100] : Les plugins commencent ici.
		 *	
		 *	SOUS MENU
		 *	$submenu['index.php'] : Tableau de bord,
		 *	$submenu['edit.php'] : Articles,
		 *	$submenu['upload.php'] : Médias,
		 *	$submenu['link-manager.php'] : Liens,
		 *	$submenu['edit.php?post_type=page'] : Pages,
		 *	$submenu['edit.php?post_type=mon-custom-type'] : Votre custom post type,
		 *	$submenu[edit-comments.php'] : Commentaires,
		 *	$submenu['themes.php'] : Apparence,
		 *	$submenu['plugins.php'] : Extensions,
		 *	$submenu['users.php'] : Utilisateurs,
		 *	$submenu['tools.php'] : Outils,
		 *	$submenu['options-general.php'] : Réglages.
		 */
		function custom_admin_menu() {
			global $menu, $submenu;
			if ( current_user_can('update_core') ){
				//unset($menu[5]);			// Articles
				unset($menu[25]);			// Commentaires
				unset($submenu['tools.php']);
				
				if(function_exists('remove_submenu_page')){
					// supprime sous menu "Widgets" dans "Apparence"
					//remove_submenu_page( 'themes.php', 'widgets.php' );
				}
				
				// affiche toutes les options, du site, dans le menu "Reglages"
				add_options_page(__('All Settings'), __('All Settings'), 'administrator', 'options.php');
				
				
			}else{
				
			}
		}
		
		/**
		 * voir la structure php de $menu et $submenu
		 */
		function custom_footer_admin () {
			if(is_admin()) {
				global $menu;
				global $submenu;
				echo 'Menu :<br/>';
				print_r($menu);
				echo '<br/>Sous-menus :<br/>';
				print_r($submenu);
			}
		}
		
		/**
		 * Aide
		 */	
		function custom_help_page() { add_filter('contextual_help', array('EeweeCustomAdmin', 'custom_page_help')); }
		function custom_page_help($help) {
		 	//echo $help; // Décommenter cette ligne si vous souhaitez garder l'aide originale et y ajouter la votre
		 	echo "<h5>Aide personnalisée</h5>";
		 	echo "<p>Votre code HTML ici.</p>";
		}
		
		/**
		 * user : ajouter champ
		 * @param array $contactmethods
		 */
		function eewee_new_contactmethods( $contactmethods ) {
		  $contactmethods['twitter'] = 'Twitter'; // Add Twitter
		  $contactmethods['googleplus'] = 'Google+'; // Add Google+
		  $contactmethods['facebook'] = 'Facebook'; // Add Facebook
		  unset($contactmethods['yim']); // Remove Yahoo IM
		  unset($contactmethods['aim']); // Remove AIM
		  unset($contactmethods['jabber']); // Remove Jabber

		  return $contactmethods;
		}
		
		/**
		 * Info : ajouter avertissement haut de page
		 */
		function eewee_admin_notice(){
			global $current_screen;
		    // sin on est sur la page "Reglages / General"
			if ( $current_screen->parent_base == 'options-general' ){
				echo '<div class="updated"><p>Attention - Changer des reglages sur ces pages peut causer des problemes au design du site!</p></div>';
		    }
		}
		
	}//fin class
	
}//fin if